# Sid Meier's Civilization 4
# Copyright Firaxis Games 2005
# AgricultureGameUtils
# Agriculture Mod By Orion Veteran
# Modular python project to eliminate or reduce merging tasks
from CvPythonExtensions import *
import CvGameUtils


# globals
gc = CyGlobalContext()

class AgricultureGameUtils:	
	def canBuild(self,argsList):
		# Agriculture Mod
		# Requires the Can Build call back to be
		# Enabled in the PythonCallbackDefines.xml file
		iX, iY, iBuild, iPlayer = argsList
		pPlot = CyMap().plot(iX, iY)
		ibCorn = gc.getInfoTypeForString("BONUS_CORN")
		ibRice = gc.getInfoTypeForString("BONUS_RICE")
		ibWheat = gc.getInfoTypeForString("BONUS_WHEAT")	
		iBuildCorn = gc.getInfoTypeForString("BUILD_CORN")
		iBuildRice = gc.getInfoTypeForString("BUILD_RICE")
		iBuildWheat = gc.getInfoTypeForString("BUILD_WHEAT")
		
		BuildList = [
			iBuildCorn,
			iBuildRice,
			iBuildWheat
		]
		
		BonusList = [
			ibCorn,
			ibRice,
			ibWheat
		]
		
		if not pPlot.isCity():
			iBonusType = pPlot.getBonusType(-1)
			if (iBonusType in BonusList):
				if (iBuild in BuildList):
					#CyInterface().addImmediateMessage("Can't Build it", "")
					return 0
				
		return -1	# Returning -1 means ignore; 0 means Build cannot be performed; 1 or greater means it can
# Agriculture Mod
	